using System;
using System.Configuration;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Web.UI;

namespace CSSamples
{
    public partial class UseGoogleYahooWms : System.Web.UI.Page, ICallbackEventHandler
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
                Map1.MapUnit = GeographyUnit.Meter;
                Map1.OnClientClick = "mapClientClick";

                Map1.MapTools.MouseCoordinate.Enabled = true;
                Map1.MapTools.PanZoomBar.Enabled = true;

                WmsOverlay wms = new WmsOverlay("WMS");
                wms.Parameters.Add("layers", "Countries02,USSTATES");
                wms.Parameters.Add("STYLE", "SIMPLE");
                wms.ServerUris.Add(new Uri("http://wmssamples.thinkgeo.com/WmsServer.aspx"));
                wms.SetBaseEpsgProjection("EPSG:900913");

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/SampleData/world/cntry02.shp"));
                worldLayer.ZoomLevelSet = new GoogleMapZoomLevelSet();
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1);
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                Proj4Projection proj4 = new Proj4Projection();
                proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                worldLayer.FeatureSource.Projection = proj4;

                LayerOverlay worldOverlay = new LayerOverlay("WorldOverlay");
                //LayerOverlay worldOverlay = new LayerOverlay("WorldOverlay", false, TileType.MultipleTile);
                worldOverlay.Layers.Add("worldLayer", worldLayer);
                //Map1.DynamicOverlay.Layers.Add(worldLayer);
                worldOverlay.Name = "DynamicLayers";
                //worldOverlay.IsVisible = false;
                //worldOverlay.SetBaseEpsgProjection("EPSG:900913");
                InMemoryFeatureLayer eachFeatureLayer = new InMemoryFeatureLayer();
                eachFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                eachFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.PointType = PointType.Bitmap;
                eachFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.Image = new GeoImage(System.Web.HttpContext.Current.Server.MapPath("~/theme/default/img/marker_blue.gif"));
                MultipointShape multiPtShape = new MultipointShape();
                multiPtShape.Points.Add(new PointShape(-9589345.0515113, 4750087.1203655));
                eachFeatureLayer.InternalFeatures.Add(new Feature(multiPtShape));
                Map1.DynamicOverlay.Layers.Add(eachFeatureLayer);



                //Map1.CustomOverlays.Add(wms);
                Map1.CustomOverlays.Add(worldOverlay);
                //Map1.CustomOverlays["WorldOverlay"].IsVisible = false;
            }
        }

        public string GetCallbackResult()
        {
            return "nothingnow";
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            //Map1.CustomOverlays["WorldOverlay"].IsVisible = false;
            InMemoryFeatureLayer eachFeatureLayer = new InMemoryFeatureLayer();
            eachFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            eachFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.PointType = PointType.Bitmap;
            eachFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.Image = new GeoImage(System.Web.HttpContext.Current.Server.MapPath("~/theme/default/img/marker_blue.gif"));
            MultipointShape multiPtShape = new MultipointShape();
            multiPtShape.Points.Add(new PointShape(-12509466.136322, 4554761.2952945));
            eachFeatureLayer.InternalFeatures.Add(new Feature(multiPtShape));
            Map1.DynamicOverlay.Layers.Clear();
            Map1.DynamicOverlay.Layers.Add(eachFeatureLayer);
        }

        protected void Button2_Click(object sender, EventArgs e)
        {
            Map1.CustomOverlays["WorldOverlay"].IsVisible = false;
        }

        protected void Map1_Click(object sender, MapClickedEventArgs e)
        {

        }
    }
}
